import time
import requests
from telegram import InlineKeyboardButton, InlineKeyboardMarkup, Update
from telegram.ext import Updater, MessageHandler, Filters, CallbackQueryHandler, CommandHandler, CallbackContext
from googletrans import Translator

# توکن ربات خود را وارد کنید
TOKEN = '7448491940:AAEY9VsY6T96cnjbOsVpCTV-vamtbJn0lXI'

# متغیر برای ذخیره‌سازی API Key
api_key = 'QAwsdCAvRsIaGhoJQvXqfwNkwuDj7D1MyGqldWn07GV068cq'

# دیکشنری برای ذخیره‌سازی آخرین زمان درخواست هر کاربر
user_last_request_time = {}

# ID مدیر (خودتان)
ADMIN_ID = 6862033009  # جایگزین کنید با شناسه تلگرام خودتان

def is_user_in_channel(bot, user_id):
    try:
        # شناسه کانال مورد نظر
        channel_id = "@lafpersian"
        # درخواست اطلاعات کاربر از کانال
        member_status = bot.get_chat_member(channel_id, user_id)
        # اگر وضعیت عضویت Member یا Administrator باشد، کاربر عضو کانال است
        if member_status.status in ['member', 'administrator', 'creator']:
            return True
        else:
            return False
    except Exception as e:
        print(f"Error checking channel membership: {e}")
        return False

def get_assistant_response(user_message):
    global api_key
    url = 'https://api.fireworks.ai/inference/v1/chat/completions'
    headers = {
        'Accept': 'application/json',
        'Content-Type': 'application/json',
        'Authorization': f'Bearer {api_key}'
    }
    payload = {
        'model': 'accounts/fireworks/models/llama-v3-70b-instruct',
        'max_tokens': 8192,
        'top_p': 1,
        'top_k': 40,
        'presence_penalty': 0,
        'frequency_penalty': 0,
        'temperature': 1,
        'messages': [
            {'role': 'user', 'content': user_message}
        ]
    }

    try:
        response = requests.post(url, headers=headers, json=payload)
        if response.status_code == 200:
            data = response.json()
            if data.get('choices'):
                assistant_response = data['choices'][0]['message']['content']
                return assistant_response
            else:
                return "No valid response received from the API."
        else:
            return f"Failed to get a response. Status code: {response.status_code}"
    except Exception as e:
        return f"An error occurred: {str(e)}"

def translate_to_farsi(text):
    translator = Translator()
    translated_text = translator.translate(text, src='en', dest='fa').text
    return translated_text

def translate_to_english(text):
    translator = Translator()
    translated_text = translator.translate(text, src='fa', dest='en').text
    return translated_text

def handle_message(update: Update, context: CallbackContext):
    user = update.message.from_user
    user_message = update.message.text
    english_user_message = translate_to_english(user_message)
    bot = context.bot
    user_id = user.id

    current_time = time.time()
    if user_id in user_last_request_time:
        elapsed_time = current_time - user_last_request_time[user_id]
        if elapsed_time < 30:
            wait_time = 30 - elapsed_time
            update.message.reply_text(f"لطفا {int(wait_time)} ثانیه دیگر صبر کنید و دوباره تلاش کنید.")
            return

    if is_user_in_channel(bot, user_id):
        # ارال پیام "منتظر باشید ⌛ "
        waiting_message = update.message.reply_text("منتظر باشید...⌛")
        assistant_response = get_assistant_response(english_user_message)
        translated_response = translate_to_farsi(assistant_response)
        # ویرایش پیام "منتظر باشید" با پاسخ دریافت شده
        context.bot.edit_message_text(chat_id=waiting_message.chat_id,
                                      message_id=waiting_message.message_id,
                                      text=translated_response)
        # به‌روزرسانی آخرین زمان درخواست کاربر
        user_last_request_time[user_id] = current_time
    else:
        keyboard = [
            [
                InlineKeyboardButton("عضویت  🚀", url="https://telegram.me/lafpersian"),
                InlineKeyboardButton("بررسی عضویت  👾", callback_data='check_membership')
            ]
        ]
        reply_markup = InlineKeyboardMarkup(keyboard)
        update.message.reply_text('هنوز عضو نشدید ! ، برای استفاده لطفا عضو کانال شود /start ⚠️', reply_markup=reply_markup)

def button(update: Update, context: CallbackContext):
    query = update.callback_query
    query.answer()
    user_id = query.from_user.id
    bot = context.bot
    if query.data == 'check_membership':
        if is_user_in_channel(bot, user_id):
            query.edit_message_text("عضو شدید ، میتونید از ربات استفاده کنید 🎉")
        else:
            query.edit_message_text("هنوز عضو نشدید ! ، برای استفاده لطفا عضو کانال شود /start ⚠️")

def start(update: Update, context: CallbackContext) -> None:
    update.message.reply_text('سلام! خوش آمدید. لطفا متن خود را ارسال کنید  🧐 ')

def admin_panel(update: Update, context: CallbackContext) -> None:
    user_id = update.message.from_user.id
    if user_id == ADMIN_ID:
        update.message.reply_text('به پنل مدیریت خوش آمدید. برای تغییر API Key دستور /setapikey را به همراه کلید جدید وارد کنید.')
    else:
        update.message.reply_text('شما دسترسی به پنل مدیریت ندارید.')

def set_api_key(update: Update, context: CallbackContext) -> None:
    user_id = update.message.from_user.id
    if user_id == ADMIN_ID:
        global api_key
        new_api_key = ' '.join(context.args)
        api_key = new_api_key
        update.message.reply_text(f'API Key جدید تنظیم شد: {new_api_key}')
    else:
        update.message.reply_text('شما دسترسی به این دستور ندارید.')

def main():
    updater = Updater(TOKEN, use_context=True)
    dp = updater.dispatcher
    dp.add_handler(CommandHandler("start", start))
    dp.add_handler(CommandHandler("admin", admin_panel))
    dp.add_handler(CommandHandler("setapikey", set_api_key, pass_args=True))
    dp.add_handler(MessageHandler(Filters.text & ~Filters.command, handle_message))
    dp.add_handler(CallbackQueryHandler(button))
    updater.start_polling()
    updater.idle()

if __name__ == '__main__':
    main()
